(* 001 bonjour *)
(* 10 oct 91 *)

(*$r+ *)
program programme_bonjour;
  uses WinTypes, WinProcs, Strings;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_message, p_w_param: Word; p_L_param: Longint): Longint; export;
    var l_poignee_contexte: hDC;
    begin (* f_traite_message *)
      case p_message of
        wm_LButtonDown :
          begin
            l_poignee_contexte:= GetDC(p_poignee_fenetre);
            TextOut(l_poignee_contexte, LoWord(p_l_param), HiWord(p_l_param),
                'Bonjour', 7);
            ReleaseDC(p_poignee_fenetre, l_poignee_contexte);
            f_traite_message:= 0;
          end;

        wm_Destroy: begin
                      (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
                      PostQuitMessage(0);
                    end;

        else (* -- pour toutes les commandes non traites dans le CASE: *)
          f_traite_message:= DefWindowProc(p_poignee_fenetre, p_message, p_W_param, p_L_param)
      end; (* case p_message *)
    end; (* f_traite_message *)

  procedure lance_instance;
    var l_classe: tWndClass;
        l_poignee_fenetre: HWnd;
        l_message: tMsg;
    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe *)
      with l_classe do
      begin
        (* -- style: quand doit redessiner etc. *)
        style:= 0;
        (* -- la procdure de traitement des messages *)
        lpfnWndProc:= @f_traite_message;
        (* -- place supplmentaire dans la classe ou la fentre *)
        cbClsExtra:= 0; cbWndExtra:= 0;
        (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
        hInstance:= System.hInstance;
        (* -- poigne de l'icne quand minimisera l'application *)
        hIcon:= LoadIcon(0, idi_Application);
        (* -- poigne du curseur *)
        hCursor:= LoadCursor(0, idc_Arrow);
        (* -- poigne du fond *)
        hbrBackground:= GetStockObject(White_Brush);
        lpszMenuName:= '';
        lpszClassName:= 'le nom de la classe';
      end; (* with l_classe *)

      RegisterClass(l_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          'le nom de la classe',
          (* -- titre affich *)
          'le titre de la fenetre',
          (* -- le style *)
          ws_OverlappedWindow,
          (* -- position et taille *)
          10, 10, 300, 200,
          (* -- la poigne de la mre et du menu *)
          0, 0,
          (* -- la poigne de cette instance *)
          hInstance,
          (* -- parametre de cration *)
          nil);

      (* -- comment afficher la fentre *)
      ShowWindow(l_poignee_fenetre, sw_ShowNormal);
      (* -- affiche la fentre *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcuperation et de ventilation des messages *)
      while GetMessage(l_message, 0, 0, 0) do
        DispatchMessage(l_message);

      (* -- fin pour cette instance *)
      Halt(0);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
