(* 002 listepol *)
(* 17 sep 94 *)

(*$r+ *)
program liste_les_polices_windows;
  uses WinTypes, WinProcs, Strings, Win31;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe polices';
        k_titre_fenetre= 'Liste';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  type tNewLogFont= record
                      police_logique: tLogFont;
                      nom_complet_true_type: array[0..2* lf_FaceSize- 1] of char;
                      nom_style_true_type: array[0..lf_FaceSize- 1] of char;
                    end;
  const k_police_max= 100;
        k_taille_nom_max= 40;
  var g_noms: array[0..k_police_max- 1] of String[k_taille_nom_max];
      g_nombre_polices: Word;

  const k_style_max= 100;
        k_taille_style_max= 40;
  var g_styles: array[0..k_style_max- 1] of string[k_taille_style_max];
      g_nombre_styles: Word;

  function f_chaine_0_en_chaine(var pv_chaine_zero; p_taille_max: word): string;
    var l_indice: integer;
        l_chaine: string;
    begin
      move(pv_chaine_zero, l_chaine[1], p_taille_max);
      l_indice:= 1;
      while (l_indice< p_taille_max) and (l_chaine[l_indice]<> chr(0)) do
        l_indice:= l_indice+ 1;
      l_chaine[0]:= chr(l_indice- 1);
      l_chaine[length(l_chaine)+ 1]:= chr(0);

      f_chaine_0_en_chaine:= l_chaine;
    end; (* f_chaine_0_en_chaine *)

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_entier_chaine(p_entier: Integer): string;
    var l_chaine: string;
    begin
      str(p_entier, l_chaine);
      f_entier_chaine:= l_chaine;
    end; (* f_entier_chaine *)

  function f_recupere_noms(var pv_police: tNewLogFont; var pv_metrique: tNewTextMetric;
      p_type_police: Word; p_pt: Pointer): Integer; export;
    var l_chaine: String;
    begin
      with pv_police, police_logique do
        g_noms[g_nombre_polices]:= f_chaine_0_en_chaine(lfFaceName, k_taille_nom_max);

      inc(g_nombre_polices);

      (* -- continuer l'numration *)
      f_recupere_noms:= 1;
    end; (* f_recupere_noms *)

  function f_recupere_styles(var pv_police: tNewLogFont; var pv_metrique: tNewTextMetric;
      p_type_police: Word; p_pt: Pointer): Integer; export;
    var l_chaine_numero: String;
    begin
      with pv_police, police_logique do
      begin
        if (p_type_police and TrueType_FontType)> 0
          then g_styles[g_nombre_styles]:= f_chaine_0_en_chaine(nom_style_true_type,
              k_taille_style_max)
          else begin
              (* -- n'a pas de nom de style. En bricole un *)
              Str(g_nombre_styles, l_chaine_numero);
              g_styles[g_nombre_styles]:= 'style_'+ l_chaine_numero;
            end;
      end;
      inc(g_nombre_styles);

      (* -- continuer l'numration *)
      f_recupere_styles:= 1;
    end; (* f_recupere_styles *)

  var (* -- indice pour bloquer l'numration *)
      g_indice_style_cherche: Word;
      (* -- globales pour afficher la police slectionne *)
      g_police_logique: tNewLogFont;
      g_type_police: Word;
      g_nouvelle_metrique: tNewTextMetric;

  function f_recupere_police(var pv_police: tNewLogFont; var pv_metrique: tNewTextMetric;
      p_type_police: Word; p_pt: Pointer): Integer; export;
    var l_chaine: String;
    begin
      if g_indice_style_cherche= 0
        then begin
            g_police_logique:= pv_police;
            g_nouvelle_metrique:= pv_metrique;
            g_type_police:= p_type_police;

            (* -- terminer l'numration *)
            f_recupere_police:= 0;
          end
        else begin
            dec(g_indice_style_cherche);
            (* -- continuer l'numration *)
            f_recupere_police:= 1;
          end;
    end; (* f_recupere_police *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)

      procedure liste_les_polices;
        var l_poignee_contexte_ecran: hDC;

        procedure affiche_noms;
          var l_indice: Word;
          begin
            for l_indice:= 0 to g_nombre_polices- 1 do
              TextOut(l_poignee_contexte_ecran, 0, 20* l_indice,
                  @g_noms[l_indice, 1], Length(g_noms[l_indice]));
          end; (* affiche_noms *)

        var l_pt_recupere_noms: tFarProc;

        begin
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- stocke les noms dans un tableau global *)
          g_nombre_polices:= 0;
          l_pt_recupere_noms:= MakeProcInstance(@f_recupere_noms, g_Instance);

          (* -- numre les polices du contexte *)
          EnumFontFamilies(l_poignee_contexte_ecran, nil, l_pt_recupere_noms, nil);
          affiche_noms;

          FreeProcInstance(l_pt_recupere_noms);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* liste_les_polices *)

      begin (* traite_wm_char *)
        case UpCase(p_caractere) of
          'L' : liste_les_polices;
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)

      const k_x_styles= 170;
            k_x_info= 300;
            ls_indice_police_selectionnee: Integer= -1;
            ls_indice_style_selectionne: Integer= -1;

      procedure inverse_chaine(p_poignee_contexte: hDC; p_x, p_y: Word; p_chaine: String);
        var l_taille: LongInt;
            l_rectangle: tRect;
         begin
          l_taille:= GetTextExtent(p_poignee_contexte, @p_chaine[1], Length(p_chaine));
          SetRect(l_rectangle, p_x, p_y, p_x+ t_long_integer(l_taille).lo, p_y+ t_long_integer(l_taille).hi);
          InvertRect(p_poignee_contexte, l_rectangle);
        end; (* inverse_chaine *)

      procedure recupere_les_styles(p_indice_nom: Word);
        var l_poignee_contexte_ecran: hDC;

        procedure affiche_styles;
          var l_indice: Word;
              l_rectangle: tRect;
          begin
            GetClientRect(p_poignee_fenetre, l_rectangle);
            l_rectangle.Left:= l_rectangle.Left+ k_x_styles;
            FillRect(l_poignee_contexte_ecran, l_rectangle, GetStockObject(White_Brush));
            for l_indice:= 0 to g_nombre_styles- 1 do
              TextOut(l_poignee_contexte_ecran, k_x_styles, 20* l_indice,
                  @g_styles[l_indice, 1], Length(g_styles[l_indice]));
          end; (* affiche_styles *)

        var l_pt_recupere_styles: tFarProc;

        begin (* recupere_les_styles *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- inverse le nom slectionn *)
          if ls_indice_police_selectionnee<> -1
            then inverse_chaine(l_poignee_contexte_ecran, 0, ls_indice_police_selectionnee* 20,
                g_noms[ls_indice_police_selectionnee]);
          inverse_chaine(l_poignee_contexte_ecran, 0, p_indice_nom* 20, g_noms[p_indice_nom]);
          (* -- mmorise le nom cliqu *)
          ls_indice_police_selectionnee:= p_indice_nom;
          ls_indice_style_selectionne:= -1;

          (* -- stocke les styles dans un tableau global *)
          g_nombre_styles:= 0;
          l_pt_recupere_styles:= MakeProcInstance(@f_recupere_styles, g_Instance);

          (* -- numre les polices du contexte *)
          EnumFontFamilies(l_poignee_contexte_ecran, @g_noms[p_indice_nom, 1],
              l_pt_recupere_styles, nil);
          affiche_styles;

          FreeProcInstance(l_pt_recupere_styles);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* recupere_les_styles *)

      procedure affiche_le_style(p_indice_style: Word);
        var l_poignee_contexte_ecran: hDC;

        procedure affiche_police;
          var l_y: Integer;

          procedure affiche(p_chaine: String);
            begin
              p_chaine:= p_chaine+ '                      ';
              TextOut(l_poignee_contexte_ecran, k_x_info, l_y,
                  @p_chaine[1], Length(p_chaine));

              inc(l_y, 20);
            end; (* affiche *)

          procedure affiche_une_phrase;
            var l_poignee_contexte_ecran_police: hDc;
                l_poignee_police: hFont;
                l_phrase: String;
            begin
              l_poignee_contexte_ecran_police:= GetDC(p_poignee_fenetre);
              Rectangle(l_poignee_contexte_ecran_police, k_x_info, l_y+ 2, k_x_info+ 250,
                l_y+ 2+ g_police_logique.police_logique.lfHeight+ 2);

              l_poignee_police:= CreateFontIndirect(g_police_logique.police_logique);

              SelectObject(l_poignee_contexte_ecran_police, l_poignee_police);
              l_phrase:= 'aAbBCcDdEe...';
              TextOut(l_poignee_contexte_ecran_police, k_x_info+ 1, l_y+ 3,
                  @l_phrase[1], Length(l_phrase));

              SelectObject(l_poignee_contexte_ecran_police, GetStockObject(System_Font));
              DeleteObject(l_poignee_police);

              ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran_police);
            end; (* affiche_une_phrase *)

          var l_detail: String;
              l_famille: Byte;

          begin (* affiche_police *)
            l_y:= 0;

            if g_type_police and Raster_FontType<> 0
              then affiche('Raster_FontType')
              else
                if g_type_police and TrueType_FontType<> 0
                  then begin
                      affiche('TrueType_FontType');
                      with g_police_logique do
                      begin
                        affiche('TT '+ f_chaine_0_en_chaine(nom_complet_true_type, 255));
                        affiche('TT '+ f_chaine_0_en_chaine(nom_style_true_type, 255));
                      end;
                    end
                  else
                    if g_type_police and Device_FontType<> 0
                      then affiche('Device_FontType vectorielle')
                      else affiche('vectorielle');

            with g_nouvelle_metrique do
            begin
              (* -- rcupre les valeurs pour afficher correctement *)
              affiche('tmHeight          '+ f_mot_chaine(tmHeight));
              affiche('tmAscent          '+ f_mot_chaine(tmAscent));
              affiche('tmDescent         '+ f_mot_chaine(tmDescent));
              affiche('tmInternalLeading '+ f_entier_chaine(tmInternalLeading));
              affiche('tmExternalLeading '+ f_mot_chaine(tmExternalLeading));
              affiche('tmAveCharWidth    '+ f_mot_chaine(tmAveCharWidth));
              affiche('tmMaxCharWidth    '+ f_mot_chaine(tmMaxCharWidth));
              affiche('tmWeight          '+ f_mot_chaine(tmWeight));
              affiche('tmItalic          '+ f_mot_chaine(tmItalic));
              affiche('tmUnderlined      '+ f_mot_chaine(tmUnderlined));
              affiche('tmStruckOut       '+ f_mot_chaine(tmStruckOut));
              affiche('tmFirstChar       '+ f_mot_chaine(tmFirstChar));
              affiche('tmLastChar        '+ f_mot_chaine(tmLastChar));
              affiche('tmDefaultChar     '+ f_mot_chaine(tmDefaultChar));
              affiche('tmBreakChar       '+ f_mot_chaine(tmBreakChar));

              affiche('tmPitchAndFamily  '+ f_mot_chaine(tmPitchAndFamily));
              l_famille:= tmPitchAndFamily And $F0;
              l_detail:= '';
              if (tmPitchAndFamily and $0F) and tmpf_Fixed_Pitch<> 0
                then l_detail:= 'chasse fixe, ';
              if (tmPitchAndFamily and $0F) and tmpf_Vector<> 0
                then l_detail:= l_detail+ 'vecteur ou TrueType, ';
              if (tmPitchAndFamily and $0F) and tmpf_TrueType<> 0
                then l_detail:= l_detail+ 'TrueType, ';
              if (tmPitchAndFamily and $0F) and tmpf_Device<> 0
                then l_detail:= l_detail+ 'Priphrique, ';
              if l_detail<> ''
                then affiche('  '+ l_detail);

              case l_famille of
                ff_Decorative : affiche(' + ff_Decorative');
                ff_DontCare : affiche(' + ff_DontCare');
                ff_Modern : affiche(' + ff_Modern (batons, avec ou sans srifs)');
                ff_Roman : affiche(' + ff_Roman (dlis avec ou sans srifs)');
                ff_Script : affiche(' + ff_Script (manuelle)');
                ff_Swiss : affiche(' = ff_Swiss (dlis, sans srifs)');
                else affiche('??? '+ f_mot_chaine(l_famille));
              end; (* case *)

              case tmCharSet of
                ANSI_CharSet : affiche('ANSI');
                Symbol_CharSet : affiche('symboles');
                ShiftJis_CharSet : affiche('ShiftJis');
                OEM_CharSet : affiche('OEM');
              end; (* case *)

              affiche('surplomb          '+ f_entier_chaine(tmOverhang));
              affiche('aspect X          '+ f_mot_chaine(tmDigitizedAspectX));
              affiche('aspect Y          '+ f_mot_chaine(tmDigitizedAspectY));

              l_detail:= '';
              if ntmFlags and ntm_Regular<> 0
                then l_detail:= 'ntm_Regular, ';
              if ntmFlags and ntm_Bold<> 0
                then l_detail:= 'ntm_Bold, ';
              if ntmFlags and ntm_Italic<> 0
                then l_detail:= 'ntm_Italic, ';
              if l_detail<> ''
                then affiche('ntmFlags:         '+ l_detail);
              affiche('ntmSizeEM         '+ f_mot_chaine(ntmSizeEm));
              affiche('ntmCellHeight     '+ f_mot_chaine(ntmCellHeight));
              affiche('ntmAvgWidth       '+ f_mot_chaine(ntmAvgWidth));
            end; (* with g_nouvelle_metrique *)

            affiche_une_phrase;
          end; (* affiche_police *)

        var l_pt_recupere_police: tFarProc;

        begin (* affiche_le_style *)
          (* -- connat la police et l'indice *)
          l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

          (* -- inverse le style slectionn *)
          if ls_indice_style_selectionne<> -1
            then inverse_chaine(l_poignee_contexte_ecran, k_x_styles, ls_indice_style_selectionne* 20,
                g_styles[ls_indice_style_selectionne]);
          inverse_chaine(l_poignee_contexte_ecran, k_x_styles, p_indice_style* 20,
              g_styles[p_indice_style]);
          ls_indice_style_selectionne:= p_indice_style;

          SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

          l_pt_recupere_police:= MakeProcInstance(@f_recupere_police, g_Instance);
          g_indice_style_cherche:= p_indice_style;
          EnumFontFamilies(l_poignee_contexte_ecran, @g_noms[ls_indice_police_selectionnee, 1],
              l_pt_recupere_police, nil);

          affiche_police;

          FreeProcInstance(l_pt_recupere_police);
          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        end; (* affiche_le_style *)

      var l_ligne: Word;

      begin (* traite_wm_l_button_down *)
        l_ligne:= p_y div 20;
        if (p_x< k_x_styles) and (l_ligne< g_nombre_polices)
          then recupere_les_styles(l_ligne)
          else
            if (p_x> k_x_styles) and (l_ligne< g_nombre_styles)
                and (ls_indice_police_selectionnee<> -1)
              then affiche_le_style(l_ligne);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: hWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
