(* 002 messsour *)
(* 02 aou 94 *)

(*$r+ *)
program affiche_messages_souris;
  uses WinTypes, WinProcs, Strings;

  type t_long_word= record
                      lo, hi: Word;
                    end;
       t_long_integer= record
                         lo, hi: Integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe souris';
        k_titre_fenetre= 'affiche messages souris';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot: 3, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_largeur_caractere: Word= 12;
          ls_hauteur_caractere: Word= 20;
          ls_y_affichage: Word= 0;
          ls_rectangle_defilement: tRect= (Left: 0; Top: 0; Right: 0; Bottom: 0);

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_L_param) pointe vers une structure CREATESTRUCT *)
      var l_poignee_contexte_ecran: hDC;
          l_metrique: tTextMetric;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));
        GetTextMetrics(l_poignee_contexte_ecran, l_metrique);

        with l_metrique do
        begin
          (* -- rcupre les valeurs pour afficher correctement *)
          ls_largeur_caractere:= tmAveCharWidth;
          ls_hauteur_caractere:= tmHeight;
        end; (* with l_metrique *)
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_create *)

    procedure traite_wm_size(p_w_param: Word; p_largeur, p_hauteur: integer);
        (* -- p_w_param est le type de changement de taille *)
        (* -- p_cx (p_L_param.Lo) est la nouvelle largeur *)
        (* -- p_cy (p_L_param.Hi) est la nouvelle hauteur *)
      var l_nombre_lignes: Word;
      begin
        l_nombre_lignes:= p_hauteur div ls_hauteur_caractere;
        ls_y_affichage:= (l_nombre_lignes- 1) * ls_hauteur_caractere;

        with ls_rectangle_defilement do
        begin
          Left:= 0; Top:= 0; Right:= p_largeur; Bottom:= l_nombre_lignes* ls_hauteur_caractere;
        end;
      end; (* traite_wm_size *)

    procedure affiche_message_souris;
      var l_poignee_contexte_ecran: hDC;
          l_x: Word;

      function f_xy: String;
        var l_x, l_y: String;
        begin
          Str(t_long_integer(p_l_param).lo: 5, l_x);
          Str(t_long_integer(p_l_param).hi: 5, l_y);
          f_xy:= l_x+ l_y;
        end; (* f_xy *)

      procedure affiche(p_chaine: String);
        begin
          TextOut(l_poignee_contexte_ecran,
            l_x, ls_y_affichage,
            @p_chaine[1], Length(p_chaine));
          inc(l_x, Length(p_chaine)* ls_largeur_caractere);
        end; (* affiche *)

      function f_classification(p_classification: LongInt): String;
        var l_classification: String;
        begin
          (* -- la classification Windows *)
          case p_classification of
            htError : l_classification:= 'htError';
            htTransparent : l_classification:= 'htTransparent';
            htNowhere : l_classification:= 'htNowhere';
            htClient : l_classification:= 'htClient--';
            htCaption : l_classification:= 'htCaption';
            htSysMenu : l_classification:= 'htSysMenu';
            htGrowBox : l_classification:= 'htGrowBox ou htSize';
            htMenu : l_classification:= 'htMenu';
            hthScroll : l_classification:= 'hthScroll';
            htvScroll : l_classification:= 'htvScroll';
            htReduce : l_classification:= 'htReduce';
            htZoom : l_classification:= 'htZoom';
            htLeft : l_classification:= 'htLeft ou htSizeFirst';
            htRight : l_classification:= 'htRight';
            htTop : l_classification:= 'htTop';
            htTopLeft : l_classification:= 'htTopLeft';
            htTopRight : l_classification:= 'htTopRight';
            htBottom : l_classification:= 'htBottom';
            htBottomLeft : l_classification:= 'htBottomLeft';
            htBottomRight : l_classification:= 'htBottomLeft ou htSizeLast';
            else l_classification:= '??? ';
          end; (* case p_classification *)

          f_classification:= l_classification;
        end; (* f_classification *)

      procedure affiche_nc_hit_test;
        begin
          (* -- appelle DefWindowProc, et met dans la variable retourne  Windows *)
          l_resultat:= DefWindowProc(p_poignee_fenetre, p_code_message, p_w_param, p_l_param);

          affiche('wm_ncHitTest'+ f_xy+ ' '+ f_classification(l_resultat));
        end; (* affiche_nc_hit_test *)

      procedure affiche_set_cursor;
        begin
          affiche('  wm_SetCursor'
            + ', h= '+ f_mot_chaine(p_w_param)
            + ', classif= '+ f_classification(LoWord(p_l_param))
            + ', numro= '+ f_mot_chaine(LoWord(p_l_param)));

          (* -- pour laisser DefWindowProc fonctionner *)
          l_appeler_defaut:= true;
        end; (* affiche_set_cursor *)

      procedure affiche_action;
        var l_nom_message, l_bouton: String;
        begin
          case p_code_message of
            wm_MouseMove : l_nom_message:= 'wm_MouseMouve';

            wm_lButtonDown : l_nom_message:= 'wm_lButtonDown';
            wm_lButtonUp : l_nom_message:= 'wm_lButtonUp';
            wm_lButtonDblClk : l_nom_message:= 'wm_lButtonDblClk';

            wm_rButtonDown : l_nom_message:= 'wm_rButtonDown';
            wm_rButtonUp : l_nom_message:= 'wm_rButtonUp';
            wm_rButtonDblClk : l_nom_message:= 'wm_rButtonDblClk';

            wm_mButtonDown : l_nom_message:= 'wm_mButtonDown';
            wm_mButtonUp : l_nom_message:= 'wm_mButtonUp';
            wm_mButtonDblClk : l_nom_message:= 'wm_mButtonDblClk';

            wm_nclButtonDown : l_nom_message:= 'wm_nclButtonDown';
            wm_nclButtonUp : l_nom_message:= 'wm_nclButtonUp';
            wm_nclButtonDblClk : l_nom_message:= 'wm_nclButtonDblClk';

            wm_ncrButtonDown : l_nom_message:= 'wm_ncrButtonDown';
            wm_ncrButtonUp : l_nom_message:= 'wm_ncrButtonUp';
            wm_ncrButtonDblClk : l_nom_message:= 'wm_ncrButtonDblClk';

            wm_ncmButtonDown : l_nom_message:= 'wm_ncmButtonDown';
            wm_ncmButtonUp : l_nom_message:= 'wm_ncmButtonUp';
            wm_ncmButtonDblClk : l_nom_message:= 'wm_ncmButtonDblClk';
          end; (* case p_code_message *)

          l_bouton:= '';
          if p_w_param and mk_lButton<> 0
            then l_bouton:= '+ gauche';
          if p_w_param and mk_rButton<> 0
            then l_bouton:= l_bouton+ '+ droite';
          if p_w_param and mk_mButton<> 0
            then l_bouton:= l_bouton+ '+ milieu';

          if p_w_param and mk_Shift<> 0
            then l_bouton:= l_bouton+ '+ Shift';
          if p_w_param and mk_Control<> 0
            then l_bouton:= l_bouton+ '+ Ctrl';

          affiche('    '+ l_nom_message+ f_xy+ ' '+ l_bouton);

          (* -- pour laisser DefWindowProc fonctionner *)
          l_appeler_defaut:= true;
        end; (* affiche_action *)

      begin (* affiche_message_souris *)
        ScrollWindow(p_poignee_fenetre, 0, - ls_hauteur_caractere,
              @ls_rectangle_defilement, nil);
        UpdateWindow(p_poignee_fenetre);

        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
            ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
        SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

        l_x:= 0;

        case p_code_message of
          wm_ncHitTest : affiche_nc_hit_test;
          wm_SetCursor : affiche_set_cursor;
          else affiche_action;
        end;

        ReleaseDc(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* affiche_message_souri *)

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      begin
        case p_caractere of
          ' ' : SetCapture(p_poignee_fenetre);
          #13 : ReleaseCapture;
          else l_appeler_defaut:= true;
        end; (* case *)
      end; (* traite_w_chare *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_Size: traite_wm_size (p_w_param, t_long_word(p_l_param).lo, t_long_word(p_l_param).hi);
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);

        wm_ncHitTest, wm_SetCursor,
          wm_MouseMove,
          wm_lButtonDown, wm_lButtonUp, wm_lButtonDblClk,
          wm_rButtonDown, wm_rButtonUp, wm_rButtonDblClk,
          wm_mButtonDown, wm_mButtonUp, wm_mButtonDblClk,

          wm_nclButtonDown, wm_nclButtonUp, wm_nclButtonDblClk,
          wm_ncrButtonDown, wm_ncrButtonUp, wm_ncrButtonDblClk,
          wm_ncmButtonDown, wm_ncmButtonUp, wm_ncmButtonDblClk:
            affiche_message_souris;

        wm_Destroy: traite_wm_destroy;

        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- demande la conversion des messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
