(* 002 selpolic *)
(* 17 sep 94 *)

(*$r+ *)
program selectionne_une_police_windows;
  uses WinTypes, WinProcs, Strings, Win31;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe selection polices';
        k_titre_fenetre= 'Selectionne';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  type tNewLogFont= record
                      police_logique: tLogFont;
                      nom_complet_true_type: array[0..2* lf_FaceSize- 1] of char;
                      nom_style_true_type: array[0..lf_FaceSize- 1] of char;
                    end;

  var g_police_logique: tLogFont;

  function f_chaine_0_en_chaine(var pv_chaine_zero; p_taille_max: word): string;
    var l_indice: integer;
        l_chaine: string;
    begin
      move(pv_chaine_zero, l_chaine[1], p_taille_max);
      l_indice:= 1;
      while (l_indice< p_taille_max) and (l_chaine[l_indice]<> chr(0)) do
        l_indice:= l_indice+ 1;
      l_chaine[0]:= chr(l_indice- 1);
      l_chaine[length(l_chaine)+ 1]:= chr(0);

      f_chaine_0_en_chaine:= l_chaine;
    end; (* f_chaine_0_en_chaine *)

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  function f_entier_chaine(p_entier: Integer): string;
    var l_chaine: string;
    begin
      str(p_entier, l_chaine);
      f_entier_chaine:= l_chaine;
    end; (* f_entier_chaine *)

  const k_selection_max= 2+ 4+ 7+ 4+ 1+ 1+ 3+ 4;
        k_selections: Array[0..k_selection_max] of String=
          ('jeu de caractres:', '    ANSI', '    OEM',
           'chasse:', '    dfaut', '    fixe', '    variable',
           'famille:', '    ff_DontCare', '    ff_Roman', '    ff_Swiss',
               '    ff_Modern', '    ff_Script', '    ff_Decorative',
           'hauteur:', 'largeur:', 'poids:', 'inclinaison:',
           'nom:',
           'respecte aspect',
           'italique', 'soulign', 'barr',
           'qualit:', '    brouillon', '    dfaut', '    copie');
  const k_y_jeu_ANSI= 1;
        k_y_jeu_OEM= 2;

        k_y_chasse_defaut= 4;
        k_y_chasse_fixe= 5;
        k_y_chasse_variable= 6;

        k_y_famille_sans_importance= 8;
        k_y_famille_roman= 9;
        k_y_famille_swiss= 10;
        k_y_famille_modern= 11;
        k_y_famille_script= 12;
        k_y_famille_decorative= 13;

        k_y_hauteur= 14;
        k_y_largeur= 15;
        k_y_poids= 16;
        k_y_inclinaison= 17;

        k_y_nom= 18;

        k_y_aspect= 19;
        k_y_italique= 20; k_y_souligne= 21; k_y_barre= 22;
        k_y_brouillon= 24; k_y_defaut= 25; k_y_copie= 26;

  const ls_jeu_de_caractere: Integer= -1;
        ls_chasse: Integer= -1;
        ls_famille: Integer= -1;
        ls_aspect: Integer= -1;
        ls_italique: Integer= -1; ls_souligne: Integer= -1; ls_barre: Integer= -1;
        ls_qualite: Integer= -1;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_l_param) pointe vers une structure CREATESTRUCT *)
      begin
        with g_police_logique do
        begin
          FillChar(g_police_logique, SizeOf(g_police_logique), 0);

          lfCharset:= ANSI_Charset; ls_jeu_de_caractere:= k_y_jeu_ANSI;
          lfHeight:= 20;
          lfPitchAndFamily:= ff_Modern or Variable_Pitch; ls_chasse:= k_y_chasse_variable;
              ls_famille:= k_y_famille_modern;
        end;
      end; (* traite_wm_create *)

    procedure inverse_chaine(p_x, p_y: Word; p_chaine: String);
      var l_poignee_contexte_ecran: hDC;
          l_taille: LongInt;
          l_rectangle: tRect;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        l_taille:= GetTextExtent(l_poignee_contexte_ecran, @p_chaine[1], Length(p_chaine));
        SetRect(l_rectangle, p_x, p_y, p_x+ t_long_integer(l_taille).lo, p_y+ t_long_integer(l_taille).hi);
        InvertRect(l_poignee_contexte_ecran, l_rectangle);
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* inverse_chaine *)

    procedure affiche_contexte_xy(p_poignee_contexte_ecran: hDC; p_x, p_y: Word;
        p_chaine: String);
      begin
        TextOut(p_poignee_contexte_ecran, p_x, p_y, @p_chaine[1], Length(p_chaine));
      end; (* affiche_xy *)

    procedure traite_wm_paint;
      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;
          l_selection: Word;
      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        for l_selection:= 0 to k_selection_max do
          affiche_contexte_xy(l_poignee_contexte_ecran, 0, l_selection* 20, k_selections[l_selection]);

        if ls_jeu_de_caractere<> -1
          then inverse_chaine(0, ls_jeu_de_caractere* 20, k_selections[ls_jeu_de_caractere]);
        if ls_chasse<> -1
          then inverse_chaine(0, ls_chasse* 20, k_selections[ls_chasse]);
        if ls_famille<> -1
          then inverse_chaine(0, ls_famille* 20, k_selections[ls_famille]);
        if ls_italique<> -1
          then inverse_chaine(0, ls_italique* 20, k_selections[ls_italique]);
        if ls_qualite<> -1
          then inverse_chaine(0, ls_qualite* 20, k_selections[ls_qualite]);

        affiche_contexte_xy(l_poignee_contexte_ecran, 100, k_y_hauteur* 20,
            f_mot_chaine(g_police_logique.lfHeight));
        affiche_contexte_xy(l_poignee_contexte_ecran, 100, k_y_largeur* 20,
            f_mot_chaine(g_police_logique.lfWidth));
        affiche_contexte_xy(l_poignee_contexte_ecran, 100, k_y_poids* 20,
            f_mot_chaine(g_police_logique.lfWeight));
        affiche_contexte_xy(l_poignee_contexte_ecran, 100, k_y_inclinaison* 20,
            f_mot_chaine(g_police_logique.lfEscapement));

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      var l_poignee_contexte_ecran: hDC;
          l_ligne: Word;

      procedure modifie_octet(var pv_ligne_selectionnee: Integer; var pv_octet: Byte;
          p_valeur: Byte);
        begin
          if pv_ligne_selectionnee<> -1
            then inverse_chaine(0, pv_ligne_selectionnee* 20, k_selections[pv_ligne_selectionnee]);
          pv_octet:= p_valeur;
          inverse_chaine(0, l_ligne* 20, k_selections[l_ligne]);
          pv_ligne_selectionnee:= l_ligne;
        end; (* modifie_octet *)

      procedure modifie_chasse(var pv_ligne_selectionnee: Integer; var pv_octet: Byte;
          p_valeur: Byte);
        var l_octet: Byte;
        begin
          modifie_octet(pv_ligne_selectionnee, l_octet, 0);
          pv_octet:= (pv_octet and $F0) or p_valeur;
        end; (* modifie_chasse *)

      procedure modifie_police(var pv_ligne_selectionnee: Integer; var pv_octet: Byte;
          p_valeur: Byte);
        var l_octet: Byte;
        begin
          modifie_octet(pv_ligne_selectionnee, l_octet, 0);
          pv_octet:= (pv_octet and $0F) or p_valeur;
        end; (* modifie_chasse *)

      procedure saisis(p_x, p_y: Word; var pv_texte: String);
        var l_message: tMsg;
            l_est_return: Boolean;
        begin
          pv_texte:= '';
          l_est_return:= false;

          repeat
            while PeekMessage(l_message, 0, 0, 0, pm_Remove) do
            begin
              if l_message.Message= wm_Quit
                then Halt(0);

              with l_message do
                if (Message= wm_KeyDown)
                  then if wParam= vk_Return
                    then l_est_return:= true
                    else
                      if wParam in [ord('0')..ord('9'), ord('A')..ord('Z'), ord(' ')]
                        then begin
                            pv_texte:= pv_texte+ chr(wParam);
                            affiche_contexte_xy(l_poignee_contexte_ecran, p_x, p_y, pv_texte);
                          end;

              TranslateMessage(l_message);
              DispatchMessage(l_message);
            end; (* while PeekMessage *)
          until l_est_return;
        end; (* saisis *)

      procedure modifie_entier(p_x, p_y: Word; var pv_valeur: Integer);
        var l_rectangle: tRect;
            l_texte: String;
            l_indice_erreur: Word;
        begin
          SetRect(l_rectangle, p_x, p_y, p_x+ 100, p_y+ 20);
          FillRect(l_poignee_contexte_ecran, l_rectangle, GetStockObject(Black_Brush));

          saisis(p_x, p_y, l_texte);
          Val(l_texte, pv_valeur, l_indice_erreur);

          FillRect(l_poignee_contexte_ecran, l_rectangle, GetStockObject(White_Brush));
          affiche_contexte_xy(l_poignee_contexte_ecran, p_x, p_y, l_texte);
        end; (* modifie_entier *)

      procedure modifie_chaine(p_x, p_y: Word; var pv_chaine);
        var l_rectangle: tRect;
            l_texte: String;
        begin
          SetRect(l_rectangle, p_x, p_y, p_x+ 100, p_y+ 20);
          FillRect(l_poignee_contexte_ecran, l_rectangle, GetStockObject(Black_Brush));

          saisis(p_x, p_y, l_texte);

          FillRect(l_poignee_contexte_ecran, l_rectangle, GetStockObject(White_Brush));
          affiche_contexte_xy(l_poignee_contexte_ecran, p_x, p_y, l_texte);

          l_texte[Length(l_texte)+ 1]:= chr(0);
          Move(l_texte[1], pv_chaine, Length(l_texte));
        end; (* modifie_chaine *)

      procedure modifie_0_1(var pv_ligne_selectionnee: Integer; var pv_octet: Byte);
        begin
          if pv_ligne_selectionnee<> -1
            then begin
                inverse_chaine(0, pv_ligne_selectionnee* 20, k_selections[pv_ligne_selectionnee]);
                pv_octet:= 0;
                pv_ligne_selectionnee:= -1;
              end
            else begin
                pv_octet:= 1;
                inverse_chaine(0, l_ligne* 20, k_selections[l_ligne]);
                pv_ligne_selectionnee:= l_ligne;
              end;
        end; (* modifie_0_1 *)

      procedure cree_et_affiche_police;
        var l_metrique: tTextMetric;
            l_nom_police: Array[0..32] of Char;

        procedure affiche_metrique;
          var l_y: Word;

          procedure affiche(p_chaine: String);
            begin
              TextOut(l_poignee_contexte_ecran, 200, l_y, @p_chaine[1], Length(p_chaine));
              inc(l_y, 20);
            end; (* affiche *)

          var l_detail: String;

          begin (* cree_et_affiche_police *)
            l_y:= 0;
            SelectObject(l_poignee_contexte_ecran, GetStockObject(System_Fixed_Font));

            with l_metrique do
            begin
              (* -- rcupre les valeurs pour afficher correctement *)
              affiche('tmHeight           '+ f_mot_chaine(tmHeight));
              affiche('tmAscent           '+ f_mot_chaine(tmAscent));
              affiche('tmDescent          '+ f_mot_chaine(tmDescent));
              affiche('tmInternalLeading  '+ f_entier_chaine(tmInternalLeading));
              affiche('tmExternalLeading  '+ f_mot_chaine(tmExternalLeading));
              affiche('tmAveCharWidth     '+ f_mot_chaine(tmAveCharWidth));
              affiche('tmMaxCharWidth     '+ f_mot_chaine(tmMaxCharWidth));
              affiche('tmWeight           '+ f_mot_chaine(tmWeight));
              affiche('tmItalic           '+ f_mot_chaine(tmItalic));
              affiche('tmUnderlined       '+ f_mot_chaine(tmUnderlined));
              affiche('tmStruckOut        '+ f_mot_chaine(tmStruckOut));
              affiche('tmFirstChar        '+ f_mot_chaine(tmFirstChar));
              affiche('tmLastChar         '+ f_mot_chaine(tmLastChar));
              affiche('tmDefaultChar      '+ f_mot_chaine(tmDefaultChar));
              affiche('tmBreakChar        '+ f_mot_chaine(tmBreakChar));

              affiche('tmPitchAndFamily   '+ f_mot_chaine(tmPitchAndFamily));
              l_detail:= '';
              if (tmPitchAndFamily and $0F) and tmpf_Fixed_Pitch<> 0
                then l_detail:= 'chasse fixe, ';
              if (tmPitchAndFamily and $0F) and tmpf_Vector<> 0
                then l_detail:= l_detail+ 'vecteur ou TrueType, ';
              if (tmPitchAndFamily and $0F) and tmpf_TrueType<> 0
                then l_detail:= l_detail+ 'TrueType, ';
              if (tmPitchAndFamily and $0F) and tmpf_Device<> 0
                then l_detail:= l_detail+ 'Priphrique, ';
              affiche('  '+ l_detail+ '                     ');

              case tmPitchAndFamily And $F0 of
                ff_Decorative : affiche('  ff_Decorative');
                ff_DontCare :   affiche('  ff_DontCare  ');
                ff_Modern :     affiche('  ff_Modern    ');
                ff_Roman :      affiche('  ff_Roman     ');
                ff_Script :     affiche('  ff_Script    ');
                ff_Swiss :      affiche('  ff_Swiss     ');
                else affiche('  ??? '+ f_mot_chaine(tmPitchAndFamily));
              end; (* case *)

              case tmCharSet of
                ANSI_CharSet : affiche('ANSI');
                Symbol_CharSet : affiche('symboles');
                ShiftJis_CharSet : affiche('ShiftJis');
                OEM_CharSet : affiche('OEM ');
              end; (* case *)

              affiche('tmOverhang         '+ f_entier_chaine(tmOverhang));
              affiche('tmDigitezedAspectX '+ f_mot_chaine(tmDigitizedAspectX));
              affiche('tmDigitizedAspectY '+ f_mot_chaine(tmDigitizedAspectY));

              affiche('GetFaceName        '+ f_chaine_0_en_chaine(l_nom_police, 255)+ '       ');
            end; (* with *)
          end; (* affiche_metrique *)

        const k_x_police= 200;
              k_y_famille= 24* 20;
        var l_poignee_contexte_ecran_police: hDc;
            l_poignee_police: hFont;
            l_phrase: String;
        begin
          l_poignee_contexte_ecran_police:= GetDC(p_poignee_fenetre);

          Rectangle(l_poignee_contexte_ecran_police, k_x_police, k_y_famille+ 2,
              k_x_police+ 150, k_y_famille+ g_police_logique.lfHeight+ 2);

          l_poignee_police:= CreateFontIndirect(g_police_logique);

          SelectObject(l_poignee_contexte_ecran_police, l_poignee_police);
          l_phrase:= 'aAgG...';
          TextOut(l_poignee_contexte_ecran_police, k_x_police+ 1, k_y_famille+ 3,
              @l_phrase[1], Length(l_phrase));

          GetTextMetrics(l_poignee_contexte_ecran_police, l_metrique);
          GetTextFace(l_poignee_contexte_ecran_police, 32, l_nom_police);
          affiche_metrique;

          SelectObject(l_poignee_contexte_ecran_police, GetStockObject(System_Font));
          DeleteObject(l_poignee_police);

          ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran_police);
        end; (* cree_et_affiche_police *)

      var l_aspect: Byte;

      begin (* traite_wm_l_button_down *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        l_ligne:= p_y div 20;
        with g_police_logique do
          if p_x< 200
            then begin
                case l_ligne of
                  k_y_jeu_ANSI : modifie_octet(ls_jeu_de_caractere, lfCharSet, Ansi_Charset);
                  k_y_jeu_OEM : modifie_octet(ls_jeu_de_caractere, lfCharSet, OEM_Charset);

                  k_y_chasse_defaut : modifie_chasse(ls_chasse, lfPitchAndFamily, Default_Pitch);
                  k_y_chasse_fixe : modifie_chasse(ls_chasse, lfPitchAndFamily, Fixed_Pitch);
                  k_y_chasse_variable : modifie_chasse(ls_chasse, lfPitchAndFamily, Variable_Pitch);

                  k_y_famille_sans_importance : modifie_police(ls_famille, lfPitchAndFamily,
                      ff_DontCare);
                  k_y_famille_roman : modifie_police(ls_famille, lfPitchAndFamily, ff_Roman);
                  k_y_famille_swiss : modifie_police(ls_famille, lfPitchAndFamily, ff_Swiss);
                  k_y_famille_modern : modifie_police(ls_famille, lfPitchAndFamily, ff_Modern);
                  k_y_famille_script : modifie_police(ls_famille, lfPitchAndFamily, ff_Script);
                  k_y_famille_decorative : modifie_police(ls_famille, lfPitchAndFamily, ff_Decorative);

                  k_y_hauteur : modifie_entier(100, k_y_hauteur* 20, lfHeight);
                  k_y_largeur : modifie_entier(100, k_y_largeur* 20, lfWidth);
                  k_y_poids : modifie_entier(100, k_y_poids* 20, lfWeight);
                  k_y_inclinaison : modifie_entier(100, k_y_inclinaison* 20, lfEscapement);

                  k_y_nom : modifie_chaine(100, k_y_nom* 20, lfFaceName);

                  k_y_aspect : begin
                                 modifie_0_1(ls_aspect, l_aspect);
                                 SetMapperFlags(l_poignee_contexte_ecran, l_aspect);
                               end;

                  k_y_italique : modifie_0_1(ls_italique, lfItalic);
                  k_y_souligne : modifie_0_1(ls_souligne, lfUnderline);
                  k_y_barre : modifie_0_1(ls_barre, lfStrikeOut);

                  k_y_brouillon : modifie_octet(ls_qualite, lfQuality, Draft_Quality);
                  k_y_defaut : modifie_octet(ls_qualite, lfQuality, Default_Quality);
                  k_y_copie : modifie_octet(ls_qualite, lfQuality, Proof_Quality);
                end; (* case *)

                cree_et_affiche_police;
              end;

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_Paint: traite_wm_paint;
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: hWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
