(* 002 bitmcurs *)
(* 07 sep 94 *)

(*$r+ *)
program bitmap_creee_par_CreateBitmap;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe bitmap curseur';
        k_titre_fenetre= 'curseur gant';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const k_largeur= 16; k_hauteur= 9;
    type t_table_bits= array[0..k_hauteur- 1] of Word;
    const vi_table_bits_and: t_table_bits= (0, 0, 0, 0, 0, 0, 0, 0, 0);
          vi_table_bits_xor: t_table_bits= (0, 0, 0, 0, 0, 0, 0, 0, 0);
          ls_poignee_bitmap_and: hBitMap= 0;
          ls_poignee_bitmap_xor: hBitmap= 0;

          k_echelle= 10;

          ls_poignee_bitmap_sauve_ecran: hBitmap= 0;
          ls_x_sauve: Integer= 0; ls_y_sauve: Integer= 0;
          ls_a_sauve: Boolean= False;

    procedure affiche_curseur(p_x, p_y: Integer);
      var l_poignee_contexte_ecran: hDC;
          l_poignee_bitmap_precedente: hBitMap;
          l_poignee_contexte_memoire: hDC;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        (* -- cre un contexte mmoire pour manipuler la bitmap *)
        l_poignee_contexte_memoire:= CreateCompatibleDc(l_poignee_contexte_ecran);

        if ls_a_sauve
          then begin
              l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire,
                  ls_poignee_bitmap_sauve_ecran);

              (* -- restaure l'cran sous la position prcdente *)
              BitBlt(l_poignee_contexte_ecran, ls_x_sauve, ls_y_sauve,
                  k_largeur* k_echelle, k_hauteur* k_echelle,
                  l_poignee_contexte_memoire, 0, 0, SrcCopy);
            end
          else begin
              ls_poignee_bitmap_sauve_ecran:= CreateCompatibleBitmap(l_poignee_contexte_ecran,
                  k_largeur* k_echelle, k_hauteur* k_echelle);
              l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire,
                  ls_poignee_bitmap_sauve_ecran);
              ls_a_sauve:= True;
            end;

        (* -- sauve l'cran sous le curseur actuel *)
        BitBlt(l_poignee_contexte_memoire, 0, 0, k_largeur* k_echelle, k_hauteur* k_echelle,
            l_poignee_contexte_ecran, p_x, p_y, SrcCopy);

        (* -- vrifie sauvegarde *)
        Rectangle(l_poignee_contexte_ecran, 180- 3, 100- 3,
            180+ k_largeur* k_echelle+ 3, 100+ k_hauteur* k_echelle+ 3);
        BitBlt(l_poignee_contexte_ecran, 180, 100, k_largeur* k_echelle, k_hauteur* k_echelle,
            l_poignee_contexte_memoire, 0, 0, SrcCopy);
        ls_x_sauve:= p_x; ls_y_sauve:= p_y;

        (* -- affiche masque AND *)
        SelectObject(l_poignee_contexte_memoire, ls_poignee_bitmap_and);
        StretchBlt(l_poignee_contexte_ecran, p_x, p_y, k_largeur* k_echelle, k_hauteur* k_echelle,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcAnd);

        (* -- masque XOR *)
        SelectObject(l_poignee_contexte_memoire, ls_poignee_bitmap_xor);
        StretchBlt(l_poignee_contexte_ecran, p_x, p_y, k_largeur* k_echelle, k_hauteur* k_echelle,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcInvert);

        (* -- supprime la bitmap: commence par la dslectionner *)
        SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap_precedente);
        DeleteDc(l_poignee_contexte_memoire);

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* affiche_curseur *)

    procedure traite_wm_create(p_pt_create_structure: pCreateStruct);
        (* -- p_pt_create_structure (p_l_param) pointe vers une structure CREATESTRUCT *)

      procedure remplis_bits(p_type: String; var pv_table_bits: t_table_bits);
        const k_motif: array[0..k_hauteur- 1, 0..k_largeur- 1] of Char=
                ('ttttttttttnttttt',
                 'ttttttttttnntttt',
                 'nnnnnnnnnnnnnntt',
                 'tniiiiiiiiiiiint',
                 'ttnibbbbbbbbbiin',
                 'tniiiiiiiiiiiint',
                 'nnnnnnnnnnnnnntt',
                 'ttttttttttnntttt',
                 'ttttttttttnttttt');
        var l_x, l_y: Word;
            l_valeur, l_octet: Word;
        begin
          for l_y:= 0 to k_hauteur- 1 do
          begin
            l_valeur:= 0;
            l_octet:= 0;
            for l_x:= 0 to k_largeur- 1 do
            begin
              l_octet:= l_octet shl 1;
              if p_type= 'AND'
                then begin
                    if k_motif[l_y, l_x] in ['t', 'i']
                      then l_octet:= l_octet+ 1;
                  end
                else
                  if k_motif[l_y, l_x] in ['i', 'b']
                    then l_octet:= l_octet+ 1;

              if (l_x+ 1) mod 8= 0
                then begin
                    l_valeur:= l_valeur shr 8;
                    l_valeur:= l_valeur+ (l_octet shl 8);
                    l_octet:= 0;
                  end;
            end; (* for l_x *)

            pv_table_bits[l_y]:= l_valeur;
          end; (* for l_y *)
        end; (* remplis_bits *)

      begin (* traite_wm_create *)
        remplis_bits('AND', vi_table_bits_and);
        remplis_bits('XOR', vi_table_bits_xor);

        (* -- cr la structure bitmap: largeur, hauteur, plans, bits/pixel *)
        ls_poignee_bitmap_and:= CreateBitmap(k_largeur, k_hauteur, 1, 1, @vi_table_bits_and);
        ls_poignee_bitmap_xor:= CreateBitmap(k_largeur, k_hauteur, 1, 1, @vi_table_bits_xor);
      end; (* traite_wm_create *)

    procedure traite_wm_paint;
      var l_structure_dessin: tPaintStruct;
          l_poignee_contexte_ecran: hDC;

          l_poignee_bitmap_precedente: hBitMap;
          l_poignee_contexte_memoire: hDC;

      begin (* traite_mwPaint *)
        l_poignee_contexte_ecran:= BeginPaint(p_poignee_fenetre, l_structure_dessin);

        MoveTo(l_poignee_contexte_ecran, 240, 0);
        LineTo(l_poignee_contexte_ecran, 240, 100);
        Ellipse(l_poignee_contexte_ecran, 400, 10, 460, 50);
        Ellipse(l_poignee_contexte_ecran, 400, 70, 460, 130);

        (* -- cre un contexte mmoire pour manipuler la bitmap *)
        l_poignee_contexte_memoire:= CreateCompatibleDc(l_poignee_contexte_ecran);

        (* -- slectionne la bitmap dans le contexte mmoire *)
        l_poignee_bitmap_precedente:= SelectObject(l_poignee_contexte_memoire,
            ls_poignee_bitmap_and);

        (* -- copie la bitmap AND vers l'cran *)
        StretchBlt(l_poignee_contexte_ecran, 10, 10, 160, 80,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcAnd);
        (* -- dbute le rsultat *)
        StretchBlt(l_poignee_contexte_ecran, 180, 10, 160, 80,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcAnd);

        SelectObject(l_poignee_contexte_memoire, ls_poignee_bitmap_xor);

        (* -- copie la bitmap XOR vers l'cran *)
        StretchBlt(l_poignee_contexte_ecran, 10, 100, 160, 80,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcInvert);
        StretchBlt(l_poignee_contexte_ecran, 180, 10, 160, 80,
            l_poignee_contexte_memoire, 0, 0, k_largeur, k_hauteur, SrcInvert);

        (* -- supprime la bitmap: commence par la dslectionner *)
        SelectObject(l_poignee_contexte_memoire, l_poignee_bitmap_precedente);
        (* -- supprime le contexte mmoire *)
        DeleteDc(l_poignee_contexte_memoire);

        EndPaint(p_poignee_fenetre, l_structure_dessin);
      end; (* traite_wmPaint *)

    procedure traite_wm_mouse_move(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      begin
        affiche_curseur(p_x, p_y);
      end; (* traite_wm_mouse_move *)

    procedure traite_wm_destroy;
      begin
        (* -- la supprime *)
        DeleteObject(ls_poignee_bitmap_and);
        DeleteObject(ls_poignee_bitmap_xor);
        DeleteObject(ls_poignee_bitmap_sauve_ecran);

        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Create: traite_wm_create(pCreateStruct(p_l_param));
        wm_MouseMove: traite_wm_mouse_move(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Paint: traite_wm_paint;
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(LtGray_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
