(* 002 deplsour *)
(* 02 aou 94 *)

(*$r+ *)
program deplace_souris;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;
        k_toute_la_region_client= nil; k_efface_fond= True;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe mousemove';
        k_titre_fenetre= 'illustre mouse move';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_mot_chaine(p_mot: Word): string;
    var l_chaine: string;
    begin
      str(p_mot: 3, l_chaine);
      f_mot_chaine:= l_chaine;
    end; (* f_mot_chaine *)

  procedure temporise(p_delai: integer);
    (* -- valeurs pour un Pentium 66 MHz *)
    var l_indice_1, l_indice_2: integer;
    begin
      for l_indice_1:= 0 to p_delai do
        for l_indice_2:= 0 to 10000 do;
    end; (* temporise *)

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const ls_x_precedent: Word= 0;
          ls_y_precedent: Word= 0;
          ls_temporisation: LongInt= 1;

    procedure traite_wm_l_button_down(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      begin
        InvalidateRect(p_poignee_fenetre, k_toute_la_region_client,
            k_efface_fond);
      end; (* traite_wm_l_button_down *)

    procedure traite_wm_mouse_move(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      var l_poignee_contexte_ecran: hDC;

      procedure affiche_x(p_x: Word; p_chaine: String);
        begin
          TextOut(l_poignee_contexte_ecran, p_x, 0, @p_chaine[1], Length(p_chaine));
        end; (* affiche_x *)

      var l_poignee_crayon, l_poignee_crayon_precedent: hPen;
          l_decalage_miliseconde: LongInt;

      begin (* traite_wm_mouse_move *)
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        l_decalage_miliseconde:= GetTickCount- GetMessageTime;
        affiche_x(0, 'tempo: '+ f_mot_chaine(ls_temporisation)
          + ', dcalage souris/traite: '+ f_mot_chaine(l_decalage_miliseconde)+ '     ');

        SetPixel(l_poignee_contexte_ecran, ls_x_precedent, ls_y_precedent, 0);
        Ellipse(l_poignee_contexte_ecran, p_x- 2, p_y- 2, p_x+ 2, p_y+ 2);

        temporise(ls_temporisation);

        l_poignee_crayon:= CreatePen(ps_solid, 1, $000000FF);
        l_poignee_crayon_precedent:= SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);

        Moveto(l_poignee_contexte_ecran, ls_x_precedent, ls_y_precedent);
        LineTo(l_poignee_contexte_ecran, p_x, p_y);

        SelectObject(l_poignee_contexte_ecran, l_poignee_crayon_precedent);
        DeleteObject(l_poignee_crayon);

        ls_x_precedent:= p_x;
        ls_y_precedent:= p_y;

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_mouse_move *)

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      begin
        case p_caractere of
          '+' : if ls_temporisation< 10000
                  then begin
                      ls_temporisation:= ls_temporisation* 10;
                      MessageBeep(0);
                    end
                  else MessageBeep(0);
          '-' : if ls_temporisation> 1
                  then ls_temporisation:= ls_temporisation div 10
                  else MessageBeep(0);
        end; (* case *)
      end; (* traite_wm_char *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_MouseMove: traite_wm_mouse_move(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_lButtonDown: traite_wm_l_button_down(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);

        wm_Destroy: traite_wm_destroy;

        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistre la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          0, 100, 300, 250,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- paramtre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de recupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touches en messages caractres *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)
