(* 002 rectangle *)
(* 15 sep 94 *)

(*$r+ *)
program illustre_figures_pleines;
  uses WinTypes, WinProcs, Strings;

  type t_long_integer= record
                         lo, hi: integer;
                       end;

  const (* -- RegisterClass *)
        k_pas_octets_classe= 0; k_pas_octets_fenetre= 0;
        k_icone_en_stock= 0; k_curseur_en_stock= 0;
        k_pas_ressource_menu= nil;
        (* -- CreateWindow *)
        k_sans_parent= 0; k_pas_parametre_de_creation= nil;
        (* -- GetMessage *)
        k_toutes_fenetres= 0; k_message_min= 0; k_message_max= 0;

  const (* -- des constantes de notre application *)
        k_nom_classe = 'classe figures pleines';
        k_titre_fenetre= 'Rectangles, Ellipses, Pies';
        (* -- la poigne du menu *)
        k_poignee_menu= 0;

  var (* -- Globales initialises par Windows au dbut de l'excution *)
      g_instance: tHandle absolute hInstance;
      g_instance_precedente: tHandle absolute hPrevInst;
      g_allure_initiale: Integer absolute CmdShow;

  function f_traite_message(p_poignee_fenetre: HWnd;
      p_code_message, p_w_param: Word; p_l_param: Longint): Longint; export;
    var l_appeler_defaut: boolean;
        l_resultat: longint;

    const k_pas= 20;

    procedure traite_wm_char(p_caractere: Char; p_l_param: LongInt);
        (* --   p_l_param : 32 bits avec rptition, Alt etc (cf doc) *)
      var l_poignee_contexte_ecran: hDC;

      procedure affiche_xy(p_x, p_y: Word; p_chaine: String);
        begin
          TextOut(l_poignee_contexte_ecran, p_x, p_y, @p_chaine[1], Length(p_chaine));
        end; (* affiche_xy *)

      procedure dessine_grille;
        var l_ligne, l_colonne: Word;
            l_rectangle: tRect;
            l_pt_rectantle: pRect;
        begin (* dessine_grille *)
          GetClientRect(p_poignee_fenetre, l_rectangle);

          with l_rectangle do
          begin
            for l_ligne:= 0 to Bottom div k_pas do
            begin
              MoveTo(l_poignee_contexte_ecran, 0, l_ligne* k_pas);
              Lineto(l_poignee_contexte_ecran, Right, l_ligne* k_pas);
            end;

            for l_colonne:= 0 to Right div k_pas do
            begin
              MoveTo(l_poignee_contexte_ecran, l_colonne* k_pas, 0);
              Lineto(l_poignee_contexte_ecran, l_colonne* k_pas, Bottom);
            end;
          end;
        end; (* dessine_grille *)

      procedure dessine_rectangles;
        var l_poignee_brosse: hBrush;
            l_poignee_crayon: hPen;

        procedure dessine_rectangle_avec_bord_pointille;
          begin
            (* -- crayon vert *)
            l_poignee_crayon:= CreatePen(ps_Dot, 1, $0000FF00);
            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
            (* -- fond transparent: le noir du fond apparatra *)
            SetBkMode(l_poignee_contexte_ecran, Transparent);
            (* -- fond rouge *)
            l_poignee_brosse:= CreateSolidBrush($000000FF);
            SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);

            Rectangle(l_poignee_contexte_ecran, 1* k_pas, 16* k_pas, 7* k_pas, 18* k_pas);

            SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
            DeleteObject(l_poignee_crayon);
            SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
            DeleteObject(l_poignee_brosse);
            SetBkMode(l_poignee_contexte_ecran, Opaque);
          end; (* dessine_rectangle_avec_bord_pointille *)

        begin (* dessine_rectangles *)
          dessine_rectangle_avec_bord_pointille;

          SetMapMode(l_poignee_contexte_ecran, mm_AnIsotropic);
          SetViewportExt(l_poignee_contexte_ecran, k_pas, k_pas);

          affiche_xy(0, 0, 'Normal 1,2,7,4');
          (* -- crayon par dfaut reste de 1 pixels, mme si pass en mode anisotropique *)
          Rectangle(l_poignee_contexte_ecran, 1, 2, 7, 4);

          affiche_xy(0, 5, 'fond rouge 1,7,7,9');
          l_poignee_brosse:= CreateSolidBrush($000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Rectangle(l_poignee_contexte_ecran, 1, 7, 7, 9);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);

          affiche_xy(0, 10, 'sans bord 1,12,7,14');
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Null_Pen));
          Rectangle(l_poignee_contexte_ecran, 1, 12, 7, 14);

          affiche_xy(0, 15, 'bord pointill 1,16,7,18');

          affiche_xy(11, 0, 'bord bleu(1) 11,2,17,4');
          (* -- dot que avec paisseur physique de 1
          l_poignee_crayon:= CreatePen(ps_Dot, 1, $00FF0000);
          *)
          l_poignee_crayon:= CreatePen(ps_Solid, 1, $00FF0000);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          Rectangle(l_poignee_contexte_ecran, 11, 2, 17, 4);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);

          affiche_xy(11, 5, 'bord couleur(3) 11,8,17,12');
          (* -- bord pais, centre colori *)
          (* --   couleur bord sera transform en couleur pleine *)
          l_poignee_crayon:= CreatePen(ps_Solid, 3, $0023A291);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          l_poignee_brosse:= CreateSolidBrush($000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Rectangle(l_poignee_contexte_ecran, 11, 8, 17, 12);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);

          affiche_xy(11, 14, 'bord interne(1) 11,16,17,19');
          l_poignee_crayon:= CreatePen(ps_InsideFrame, 1, $0023A291);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          l_poignee_brosse:= CreateSolidBrush($00FF00FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Rectangle(l_poignee_contexte_ecran, 11, 16, 17, 19);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);
        end; (* dessine_rectangles *)

      procedure dessine_ellipses;
        var l_poignee_brosse: hBrush;
            l_poignee_crayon: hPen;
        begin (* dessine_ellipses *)
          SetMapMode(l_poignee_contexte_ecran, mm_AnIsotropic);
          SetViewportExt(l_poignee_contexte_ecran, k_pas, k_pas);

          affiche_xy(0, 0, 'Normal 1,2,7,4');
          Ellipse(l_poignee_contexte_ecran, 1, 2, 7, 4);

          affiche_xy(0, 5, 'fond rouge 1,7,7,9');
          l_poignee_brosse:= CreateSolidBrush($000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Ellipse(l_poignee_contexte_ecran, 1, 7, 7, 9);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);

          affiche_xy(0, 10, 'sans bord 1,12,7,14');
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Null_Pen));
          Ellipse(l_poignee_contexte_ecran, 1, 12, 7, 14);

          affiche_xy(11, 0, 'bord bleu(1) 11,2,17,4');
          l_poignee_crayon:= CreatePen(ps_Solid, 1, $00FF0000);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          Ellipse(l_poignee_contexte_ecran, 11, 2, 17, 4);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);

          affiche_xy(11, 5, 'bord couleur(3) 11,8,17,12');
          (* -- bord pais, centre colori *)
          (* --   couleur bord sera transform en couleur pleine *)
          l_poignee_crayon:= CreatePen(ps_Solid, 3, $0023A291);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          l_poignee_brosse:= CreateSolidBrush($000000FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Ellipse(l_poignee_contexte_ecran, 11, 8, 17, 12);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);

          affiche_xy(11, 14, 'bord interne(1) 11,16,17,19');
          l_poignee_crayon:= CreatePen(ps_InsideFrame, 1, $0023A291);
          SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
          l_poignee_brosse:= CreateSolidBrush($00FF00FF);
          SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
          Ellipse(l_poignee_contexte_ecran, 11, 16, 17, 19);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
          DeleteObject(l_poignee_crayon);
          SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
          DeleteObject(l_poignee_brosse);
        end; (* dessine_ellipses *)

      procedure dessine_pies;

        procedure dessine_en_fin;
          var l_poignee_contexte_ecran: hDC;
              l_poignee_crayon: hPen;
              l_x, l_y: Integer;
          begin
            l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

            l_poignee_crayon:= CreatePen(ps_Solid, 1, $000000FF);
            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);

            l_x:= 2* k_pas; l_y:= k_pas* 14;
            Rectangle(l_poignee_contexte_ecran, l_x, l_y, l_x+ 5* k_pas- 1, l_y+ 3* k_pas- 1);
            Pie(l_poignee_contexte_ecran, l_x, l_y, l_x+ 5* k_pas- 1, l_y+ 3* k_pas- 1,
                l_x+ 5* k_pas, l_y+ (3* k_pas- 1) div 2,   l_x+ (5* k_pas- 1) div 2, l_y);

            l_x:= 12* k_pas; l_y:= k_pas* 14;
            Rectangle(l_poignee_contexte_ecran, l_x, l_y, l_x+ 6* k_pas, l_y+ 4* k_pas);
            Pie(l_poignee_contexte_ecran, l_x, l_y, l_x+ 6* k_pas, l_y+ 4* k_pas,
                l_x+ 6* k_pas, l_y+ 4* k_pas div 2,   l_x+ 6* k_pas div 2, l_y);

            SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
            DeleteObject(l_poignee_crayon);

            ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
          end; (* dessine_en_fin *)

        procedure dessine_en_gros;
          var l_poignee_brosse: hBrush;
              l_poignee_crayon: hPen;
          begin (* affiche_pie *)
            SetMapMode(l_poignee_contexte_ecran, mm_AnIsotropic);
            SetViewportExt(l_poignee_contexte_ecran, k_pas, k_pas);

            affiche_xy(0, 0, 'Diamtre impair: 2,2,7,5');
            affiche_xy(12, 0, 'Diamtre pair: 12,2,18,6');

            SelectObject(l_poignee_contexte_ecran, GetStockObject(Null_Brush));
            (* -- dessine avec gros stylo *)
            l_poignee_crayon:= CreatePen(ps_solid, 1, $0000FF00);
            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
            Ellipse(l_poignee_contexte_ecran, 2, 2, 7, 5);
            Ellipse(l_poignee_contexte_ecran, 12, 2, 18, 6);
            SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
            DeleteObject(l_poignee_crayon);

            l_poignee_crayon:= CreatePen(ps_Solid, 1, $000000FF);
            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);
            Rectangle(l_poignee_contexte_ecran, 1, 7, 8, 12);
            Rectangle(l_poignee_contexte_ecran, 11, 7, 19, 13);
            SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
            DeleteObject(l_poignee_crayon);

            (* -- tarte en violet *)
            l_poignee_brosse:= CreateSolidBrush($00FF7FFF);
            SelectObject(l_poignee_contexte_ecran, l_poignee_brosse);
            (* -- taille 0: 1 pixel (pas 20) *)
            l_poignee_crayon:= CreatePen(ps_Solid, 0, $000000FF);
            SelectObject(l_poignee_contexte_ecran, l_poignee_crayon);

            (* -- sans corriger vers l'infini *)
            Pie(l_poignee_contexte_ecran, 2, 8, 7, 11,     7,  (8+ 11) div 2,   (2+ 7) div 2, 8);
            (* -- corrige vers - infini *)
            Pie(l_poignee_contexte_ecran, 2, 8, 7, 11,     -1600,  (8+ 12) div 2,   (2+ 7) div 2, 1600);

            Pie(l_poignee_contexte_ecran, 12, 8, 18, 12,   18, (8+ 13) div 2,   (12+ 18) div 2, 8);
            Pie(l_poignee_contexte_ecran, 12, 8, 18, 12,   12, (8+ 13) div 2,   (12+ 18) div 2, 12);

            SelectObject(l_poignee_contexte_ecran, GetStockObject(White_Brush));
            DeleteObject(l_poignee_brosse);
            SelectObject(l_poignee_contexte_ecran, GetStockObject(Black_Pen));
            DeleteObject(l_poignee_crayon);
          end; (* dessine_en_gros *)

        begin (* dessine_pies *)
          dessine_en_fin;
          dessine_en_gros;
        end; (* dessine_pies *)

      begin (* traite_wm_char *)
        InvalidateRect(p_poignee_fenetre, nil, true);
        UpdateWindow(p_poignee_fenetre);

        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);
        dessine_grille;

        case UpCase(p_caractere) of
          'R' : dessine_rectangles;
          'E' : dessine_ellipses;
          'P' : dessine_pies;
        end; (* case *)

        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_char *)

    procedure traite_wm_mouse_move(p_bouton_ou_touche: Word; p_x, p_y: integer);
        (* -- p_bouton_ou_touche (p_w_param): indique les touches / boutons enfoncs *)
        (* -- p_x (p_l_param.lo): est l'abcisse du pointeur *)
        (* -- p_y (p_l_param.hi): est l'ordonne du pointeur *)
      const k_largeur= k_pas+ 2; k_hauteur= k_pas+ 2; k_echelle= 5;
      var l_poignee_contexte_ecran: hDC;
      begin
        l_poignee_contexte_ecran:= GetDC(p_poignee_fenetre);

        Rectangle(l_poignee_contexte_ecran, k_pas* 22, k_pas,
            k_pas* 22+ k_largeur* k_echelle+ 4, k_pas+ k_hauteur* k_echelle+ 4);

        StretchBlt(l_poignee_contexte_ecran, 2+ k_pas* 22, 2+ k_pas,
                k_largeur* k_echelle, k_hauteur* k_echelle,
            l_poignee_contexte_ecran, p_x, p_y, k_largeur, k_hauteur, SrcCopy);
        ReleaseDC(p_poignee_fenetre, l_poignee_contexte_ecran);
      end; (* traite_wm_mouse_move *)

    procedure traite_wm_destroy;
      begin
        (* -- demande  Windows d'envoyer wm_Quit  notre instance *)
        PostQuitMessage(0);
      end; (* traite_wmDestroy *)

    begin (* f_traite_message *)
      (* -- par dfaut, si traite un message, retourne 0  Windows *)
      l_resultat:= 0;
      (* -- par dfaut, si traite un message, il ne faut pas appeler DefWindowProc *)
      l_appeler_defaut:= false;

      case p_code_message of
        wm_Char: traite_wm_char(Chr(p_w_param), p_l_param);
        wm_MouseMove: traite_wm_mouse_move(p_w_param,
            t_long_integer(p_l_param).lo, t_long_integer(p_l_param).hi);
        wm_Destroy: traite_wm_destroy;
        else (* -- pour toutes les commandes non traites dans le case: *)
          l_appeler_defaut:= true;
      end; (* case p_message *)

      (* -- traite ici les messages non traits dans le CASE *)
      if l_appeler_defaut
        then f_traite_message:= DefWindowProc(p_poignee_fenetre, p_code_message,
            p_w_param, p_l_param)
        else f_traite_message:= l_resultat;
    end; (* f_traite_message *)

  procedure lance_instance;

    procedure enregistre_classe(p_style_classe: Word; p_pt_fonction_messages: TFarProc;
        p_octets_classe, p_octets_fenetre: Integer; p_poignee_instance: tHandle;
        p_poignee_icone: hIcon; p_poignee_curseur: hCursor; p_poignee_brosse: hBrush;
        p_nom_ressource_menu: pChar; p_nom_classe: pChar);
      var l_classe: tWndClass;
      begin
        with l_classe do
        begin
          (* -- style: quand doit redessiner etc. *)
          style:= p_style_classe;
          (* -- la procdure de traitement des messages *)
          lpfnWndProc:= p_pt_fonction_messages;
          (* -- place supplmentaire dans la classe ou la fentre *)
          cbClsExtra:= p_octets_classe; cbWndExtra:= p_octets_fenetre;
          (* -- poigne de l'instance qui a enregistr la classe, pour pouvoir dtruire *)
          hInstance:= p_poignee_instance;
          (* -- poignes de l'icne, du curseur et du fond *)
          hIcon:= p_poignee_icone; hCursor:= p_poignee_curseur; hBrBackGround:= p_poignee_brosse;
          lpszMenuName:= p_nom_ressource_menu;
          lpszClassName:= p_nom_classe;
        end; (* with l_classe *)

        if not RegisterClass(l_classe)
          then Halt(255);
      end; (* enregistre_classe *)

    var l_poignee_fenetre: HWnd;
        l_message: TMsg;

    begin (* lance_instance *)
      (* -- dfinit une nouvelle classe si c'est le premier appel *)
      if g_instance_precedente = 0
        then enregistre_classe(cs_vRedraw or cs_hRedraw,
                @f_traite_message,
                k_pas_octets_classe, k_pas_octets_fenetre,
                g_instance,
                LoadIcon(k_icone_en_stock, idi_Application),
                LoadCursor(k_curseur_en_stock, idc_Arrow),
                GetStockObject(White_Brush),
                k_pas_ressource_menu, k_nom_classe);

      l_poignee_fenetre := CreateWindow(
          (* -- le nom identifiant la classe *)
          k_nom_classe,
          (* -- titre affich *)
          k_titre_fenetre,
          (* -- le style *)
          ws_Overlapped or ws_Caption or ws_SysMenu or ws_ThickFrame
              or ws_MinimizeBox or ws_MaximizeBox,
          cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault,
          (* -- la poigne de la mre *)
          k_sans_parent,
          (* -- poigne du menu *)
          k_poignee_menu,
          (* -- le numro de cette instance *)
          g_instance,
          (* -- parametre de cration *)
          k_pas_parametre_de_creation);

      (* -- affiche la fentre en effaant la zone client *)
      ShowWindow(l_poignee_fenetre, g_allure_initiale);
      (* -- envoie wm_Paint pour redessiner la zone client *)
      UpdateWindow(l_poignee_fenetre);

      (* -- la boucle de rcupration et de ventilation des messages *)
      while GetMessage(l_message, k_toutes_fenetres, k_message_min, k_message_max) do
      begin
        (* -- transforme les messages touche en messages caractre *)
        TranslateMessage(l_message);
        (* -- appelle la procdure de traitement *)
        DispatchMessage(l_message);
      end;

      (* -- fin pour cette instance *)
      Halt(l_message.WParam);
    end; (* lance_instance *)

  begin (* principal *)
    lance_instance;
  end. (* principal *)

